/**
 * Created by bjoern on 22.04.17.
 */
"use strict";


function getNodesAsArray(root) {
    let nodes = [];

    function trav(node) {
        nodes.push(node);

        if (!node) return;
        if (!node.children) return;
        for (let i = 0; i < node.children.length; i++) {
            let child = node.children[i];
            trav(child);
        }
    }

    trav(root);
    return nodes;
}

function getDataAsFlatArray(root) {
    let nodes = getNodesAsArray(root);

    // thanks to http://stackoverflow.com/a/39000004/5132456
    function flattenArray(arr) {
        let result = [];
        for (let i = 0, length = arr.length; i < length; i++) {
            const value = arr[i];
            if (Array.isArray(value)) {
                for (let i = 0, length = value.length; i < length; i++) {
                    const value2 = value[i];
                    if (Array.isArray(value2)) {
                        flattenArray(value2, result)
                    } else {
                        result.push(value2)
                    }
                }
            } else {
                result.push(value)
            }
        }
        return result
    }

    return flattenArray(nodes.map(n => n.data));
}

function addParentsToNodes(root) {

    function trav(node) {
        if (!node) return;
        if (!node.children) return;
        for (let i = 0; i < node.children.length; i++) {
            let child = node.children[i];
            trav(child);
            child.parent = node;
        }
    }

    root.parent = null;
    trav(root);
}


/* traversale-template

 function trav(node) {
 if (!node) return;
 if (!node.children) return;
 for (let i = 0; i < node.children.length; i++) {
 let child = node.children[i];
 trav(child);
 }
 }

 trav(root);

 */

module.exports = {getNodesAsArray, getDataAsFlatArray, addParentsToNodes};