/**
 * Created by bjoern on 22.04.17.
 */

"use strict";

const cheerio = require('cheerio');
const url = require('url');


function dummy(){return []}

function greedy(html, sourceUrlString) {
    let $ = cheerio.load(html);

    return $('a').map(function () {
        let href_temp = $(this).attr("href");
        if (!href_temp) return;
        let href = url.parse(url.resolve(sourceUrlString, href_temp));
        return {
            weight: 1,
            url: url.format(href, {fragment: false, unicode: false, auth: true, search: true})
        };
    }).filter(function () {
        return this
    }).toArray();
}

function relative(html, sourceUrlString) {

    let allChildren = greedy(html, sourceUrlString);
    let source = url.parse((sourceUrlString));

    for (let i = allChildren.length - 1; i >= 0; i--) {
        let found_url = url.parse(allChildren[i].url);
        if (found_url.host != source.host)
            allChildren.splice(i, 1);
    }

    return allChildren;
}

function selectorFactory (selector) {
    return function getNextPageUrlParser(html, sourceUrlString) {
        let $ = cheerio.load(html);

        return $(selector).map(function () {
            let href_temp = $(this).attr("href");
            if (!href_temp) return;
            let href = url.parse(url.resolve(sourceUrlString, href_temp));
            return {
                weight: 1,
                url: url.format(href)
            };
        }).filter(function () { // remove falsy results
            return this
        }).toArray();
    }
}


module.exports = {dummy, greedy, relative, selectorFactory};
